#include <avgui.h>
#include <avdata.h>

#define cmReady   0x2010
#define cmLearn   0x2011
#define cmSend    0x2012

#define MAXIRBYTES 1625

#define A10_UART_XTAL_FREQ       1843200
#define A10_UART_DL_BIT          0b10000000
#define A10_UART_LCR_MASK_PAR    0b00111000

#define A10_UART_DL_LSB          0x30  /* r/w = Divisor latch lsb.*/
#define A10_UART_DL_MSB          0x31  /* r/w = Divisor latch msb. */
#define A10_UART_RBR             0x30  /* r   = Receive buffer register.*/
#define A10_UART_THR             0x30  /* w   = Transmitter holding register*/
#define A10_UART_IER             0x31  /* r/w = Interrupt enable register. */
#define A10_UART_IIR             0x32  /* r   = Interrupt identification register. */
#define A10_UART_FCR             0x32  /* w   = FIFO control register. */
#define A10_UART_LCR             0x33  /* r/w = Line control register. */
#define A10_UART_MCR             0x34  /* r/w = Modem control register. */
#define A10_UART_LSR             0x35  /* r/w = Line status register.  */
#define A10_UART_MSR             0x36  /* r/w = Modem status register. */ 
#define A10_UART_SCR             0x37  /* r/w = Scratch register.  */

#define PORT_IR       0
#define PORT_RS232    1

#define BAUD_115200   1
#define BAUD_57600    2
#define BAUD_14400    8
#define BAUD_9600    12
#define BAUD_4800    24
#define BAUD_2400    48
#define BAUD_1200    96
