REM HANOI TOWERS v1.0
REM 25/11/00 (c) 
REM JM BUNOUF
REM FRANCE
REM 
REM +----------------+
REM | INITIALISATION |
REM +----------------+
bkoff
troff
c.
ti. "Hanoi towers"
p. "HANOI TOWERS for AVIGO" 
p. "by JM BUNOUF"
p.
p.
p. "   --++# Rules of game #++--"
p.
p. "    You have to move all discs"
p. "    from tower 1 to tower 3." 
p. "    Use tower 2 to help you."
p. "    You can't put a disc on a"
p. "    smaller one. To move a "
p. "    disc, click on towers."
p.
p.
p.
p.
p. "  ...click on screen to continue..."
ip.
60
c.
li. 3,47,156,47,0
li. 3,95,156,95,0
li. 3,143,156,143,0
li. 3,191,156,191,0
l. 5,1
p. "-- 3 DISCS --  (easy) "
l. 5,5
p. "-- 4 DISCS --"
l. 5,9
p. "-- 5 DISCS --"
l. 5,13
p. "-- 6 DISCS --"
l. 5,17
p. "-- 7 DISCS -- (hard)"
l. 1,19 
p. "    Click to select difficulty"
ip.
c.
y=py.
n=3
if y>47 then n=4
if y>95 then n=5
if y>143 then n=6
if y>191 then n=7
go. 110
l. 1,19
p. "Working..."
a$=ri$. "7654321",n
cl. b$
cl. c$
m=0
s=1
p=1
for i=1 to n
h=i
t$=mi$. a$,i,1
go. 120
n.

REM +------+
REM | GAME |
REM +------+
70
l. 1,19
p. "starting tower "
ip.
z=py.
l. 1,19
p. "ending tower   "
ip.
y=py.
l. 1,19
p. "Moving...      "
i=2
if z<80 then i=1
if z>150 then i=3
f=2
if y<80 then f=1
if y>150 then f=3
go. 100
l. 12,19
p. m;" move(s)";
t=len c$
if t<n then g. 70

REM +-------------+
REM | END OF GAME |
REM +-------------+
for i=1 to 7
bz. i,1
n.
for i=1 to 7
bz. i,1
n.
if n=3 then o=7
if n=4 then o=15
if n=5 then o=31
if n=6 then o=63
if n=7 then o=127
m$="Perfect ! This is the optimal solution !"
if m=o then g. 90
m$=st$. o
m$="Well done ! But you can do it with only "+m$+" moves..."
90
me. m$,1024
a=me. "Do you want to play again ?",770
if a=5 then g. 60
c.
e.

REM +-------------------+
REM | CONTROL/MOVE DISC |
REM +-------------------+
100 
if i=f then g. 202
if i=1 then s$=a$
if i=2 then s$=b$
if i=3 then s$=c$
if f=1 then d$=a$
if f=2 then d$=b$
if f=3 then d$=c$
t=len s$
if t=0 then g. 200
t$=ri$. s$,1
r=t-1
if r>0 then u$=le$. s$,r el. cl. u$
q=len d$
if q=0 then g. 101
e$=ri$. d$,1
if e$<t$ then g. 201
101
s$=u$
d$=d$+t$
h=t
p=i
s=2
go. 120
h=q+1
p=f
s=1
go. 120
m=m+1
if i=1 then a$=s$
if i=2 then b$=s$
if i=3 then c$=s$
if f=1 then a$=d$
if f=2 then b$=d$
if f=3 then c$=d$
r.

REM +---------+
REM | DISPLAY |
REM +---------+
110
li. 1,79,158,79,4
li. 1,149,158,149,4
li. 1,219,158,219,0
li. 90,220,90,238,0
re. 79,64,149,70,0
pm. 1
l. 1,1
p. " Tower 1 "
re. 111,64,117,19,0
re. 79,134,149,140,0
l. 1,7
p. " Tower 2 "
re. 111,134,117,89,0
l. 1,13
p. " Tower 3 "
re. 79,204,149,210,0
re. 111,204,117,159,0
pm. 0
r.

REM +------------+
REM | draw  disc |
REM +------------+
120
t=a. t$
h=70*p-6*h-4
j=h+3
if t=49 then fr. 107,h,121,j,s
if t=50 then fr. 103,h,125,j,s
if t=51 then fr. 99,h,129,j,s
if t=52 then fr. 95,h,133,j,s
if t=53 then fr. 91,h,137,j,s
if t=54 then fr. 87,h,141,j,s
if t=55 then fr. 83,h,145,j,s
if s<2 then g. 121
li. 111,h,111,j,0
li. 117,h,117,j,0
121
r.

REM +----------+
REM | MESSAGES |
REM +----------+
200
me. "illegal move : there is no disc to move !",1024
r.
201
me. "illegal move : you can't put a disc on a smaller one !",1024
r.
202
me. "illegal move : initial and final towers are the same !",1024
r.
